package com.fp.persistence.pcustomer.balance;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.HibernateBean;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla TCUSTBALANCEFINANCIAL
 */
@Entity(name = "TcustBalanceFinancial")
@Table(name = "TCUSTBALANCEFINANCIAL")
public class TcustBalanceFinancial extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TcustBalanceFinancial
     */
    @EmbeddedId
    private TcustBalanceFinancialKey pk;

    @Column(name = "VALUEACCOUNT", nullable = true)
    /**
     * Saldo de la cuenta en el balance
     */
    private BigDecimal valueaccount;

    @Column(name = "DATEFROM", nullable = true)
    /**
     * Fecha desde la cual esta vigente el registro
     */
    private Timestamp datefrom;

    @Column(name = "INGRESSUSER", nullable = true)
    /**
     * Codigo de usuario que crea el registro
     */
    private String ingressuser;

    @Column(name = "MODIFYUSER", nullable = true)
    /**
     * Codigo de usuario que modifica datos del registro
     */
    private String modifyuser;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;

    /**
     * Contructor por defecto
     */
    public TcustBalanceFinancial() {
    }

    /**
     * Contructor de TcustBalanceFinancial
     * 
     * @param pPk Clave Primaria del entity
     */
    public TcustBalanceFinancial(TcustBalanceFinancialKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TcustBalanceFinancial
     */
    public static TcustBalanceFinancial find(EntityManager pEntityManager, TcustBalanceFinancialKey pKey) throws Exception {
        TcustBalanceFinancial obj = pEntityManager.find(TcustBalanceFinancial.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TcustBalanceFinancial
     * 
     * @return El objeto que referencia a la Clave primaria de TcustBalanceFinancial
     */
    public TcustBalanceFinancialKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TcustBalanceFinancial
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TcustBalanceFinancial
     */
    public void setPk(TcustBalanceFinancialKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de valueaccount
     * 
     * @return valor de valueaccount
     */
    public BigDecimal getValueaccount() {
        return this.valueaccount;
    }

    /**
     * Fija el valor de valueaccount
     * 
     * @param pValueaccount nuevo Valor de valueaccount
     */
    public void setValueaccount(BigDecimal pValueaccount) {
        this.valueaccount = pValueaccount;
    }

    /**
     * Obtiene el valor de datefrom
     * 
     * @return valor de datefrom
     */
    public Timestamp getDatefrom() {
        return this.datefrom;
    }

    /**
     * Fija el valor de datefrom
     * 
     * @param pDatefrom nuevo Valor de datefrom
     */
    public void setDatefrom(Timestamp pDatefrom) {
        this.datefrom = pDatefrom;
    }

    /**
     * Obtiene el valor de ingressuser
     * 
     * @return valor de ingressuser
     */
    public String getIngressuser() {
        return this.ingressuser;
    }

    /**
     * Fija el valor de ingressuser
     * 
     * @param pIngressuser nuevo Valor de ingressuser
     */
    public void setIngressuser(String pIngressuser) {
        this.ingressuser = pIngressuser;
    }

    /**
     * Obtiene el valor de modifyuser
     * 
     * @return valor de modifyuser
     */
    public String getModifyuser() {
        return this.modifyuser;
    }

    /**
     * Fija el valor de modifyuser
     * 
     * @param pModifyuser nuevo Valor de modifyuser
     */
    public void setModifyuser(String pModifyuser) {
        this.modifyuser = pModifyuser;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return this.recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        this.recordversion = pRecordversion;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TcustBalanceFinancial)) {
            return false;
        }
        TcustBalanceFinancial that = (TcustBalanceFinancial) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementación del metodo hashCode de la la entidad TcustBalanceFinancial
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementación toString
     */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementación de la creación de un bean en blanco TcustBalanceFinancial
     */
    @Override
    public Object createInstance() {
        TcustBalanceFinancial instance = new TcustBalanceFinancial();
        instance.setPk(new TcustBalanceFinancialKey());
        return instance;
    }

    /**
     * Clona la entidad TcustBalanceFinancial
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TcustBalanceFinancial p = (TcustBalanceFinancial) this.clone();
        p.setPk((TcustBalanceFinancialKey) this.pk.cloneMe());
        return p;
    }

    public Object getId() {
        return this.pk;
    }
}
